﻿/******************************************************************************
 * 文件名称: Structs.cs
 * 文件说明: 结构体的封装
 * 当前版本: V1.0
 * 创建日期: 2022-04-12
 *
 * 2020-04-12: 增加 businessDLLInvoke 方法




******************************************************************************/
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PTMedicalInsurance.Variables
{
    //配置信息
    public struct IrisConfigue{
        public string ip;
        public string url;
        public string authorization;
    }

    //配置信息
    public struct YHConfigue
    {
        public string InsuHosCode;
        public string url;
        public string ecurl;        
    }

    //接口固定信息
    public struct InterfaceInfo
    {
        public int interfaceDr;
        public int interfaceDr_TY;
        public string interfaceID;
        public string interfaceName;
        public int hisHospitalDr;
        public int hospitalDr;
        public string hospitalName;
        public string hospitalNO;
        public string centerURL;
        public string cardURL;
        public string ecURL;
        public string areaCode;
        public string dllName;
        public string version;
        public string signatureType;
        public string recivedSystem;
        public string AK;
        public string SK;
        public string dev_no;
        public string dev_safe_info;
        public string cainfo;
        public string BusinessID;
        public string CreditID;
        public string operatoType;
        public string fileName;
        public string CommonInterfaceDr;
        public string SignType;

        public string mutualAidCenterURL;//共济的时候可能存在省医保和市医保混用的情况
        public int mutualAidInterfaceDr;//共济选择的接口ID
        public string mutualAidHospitalAreaCode;
        public string mutualAidPatientAreaCode;

        public string businessType;

    }

    //用户信息
    public struct User
    {
        public string ID;
        public string name;
        public string type;
        public string officeID;
        public string officeName;
        public string deptID;
        public string deptName;
    }

    //患者信息
    public struct Patients
    {
        public int adm_Dr;
        public string admID;
        public string mdtrtID;
        public string mdtrtID_GJSQR;
        public string name;
        public string name_GJSQR;
        public string name_SYR;
        public string gend;
        public string gend_GJSQR;
        public string naty;
        public string naty_GJSQR;
        public string age;
        public string age_GJSQR;
        public string brdy;
        public string brdy_GJSQR;
        public string psn_no;
        public string psn_no_GJSQR;
        public string psn_cert_type_GJSQR;
        public string insuType;
        public string insuType_GJSQR;
        public string medType;
        public string IDNO;//身份证号码
        public string certNO;
        public string certNO_GJSQR;
        public string certNO_SYR;        
        public string certType;
        public string certType_GJSQR;
        public string mdtrtcertNO;
        public string mdtrtcertType;
        public string mdtrtcertNO_GJSQR;
        public string mdtrtcertType_GJSQR;
        public string admDiagCode; //Admission Diagnosis
        public string admDiagName;
        public string discDiagCode; //Discharge Diagnosis
        public string discDiagName;
        public string insuplc_admdvs;
        public string mdtrtarea_admvs;
        public string insuplc_admdvs_GJSQR;
        public string ecToken; //电子凭证令牌
        public Card card;
        public string settlID;
        public string settlID_GJSQR;
        public string billID;
        public string recordID;
        public string psn_insu_date;
        public string cvlserv_flag;
        public string cvlserv_flag_GJSQR;
        public string balc;
        public string balc_GJSQR;
        public string emp_name;
        public string psn_type;
        public string psn_type_GJSQR;
        public string psn_insu_stas;
        public string paus_insu_date;
        public int OtherProv;
        public string DisType; //病种类型

        public string disCode;
        public string disName;

        public string DiseasecCode;  //病种编码
        public string DiseasecName;  //病种名称

        public string SettID_HISJSB;
        public string SettID_YBJSB;

        public string RYorCY;   //1入院 2出院

        public Boolean AccountMutualAidPay;  //账户共济结算 
        public string CrossYearHosp;   //是否跨年结算
        public string IptType;         //住院类型

        public string ExpContent; //扩展字段
        public int admType;

        public string mutualAidPay; //账户代支金额

        public string patInfo_mutualAidPay;
        public JObject joSettlInfoOfMutualAid;
    }

    public struct Card
    {
        public string type;
        public string SN;
        public string SN_GJSQR;
        public string password;
        public string level;
        public string NO;
        public string Cardtoken;
        public string Cardtoken_GJSQR;
        public string SearchAdmKey;
        public string SearchAdmCode;
        public string SearchAdmName;
        public string QrCode;
    }

    //费用信息
    public struct Fees
    {
        public int adm_Dr;
        public string mdtrtID;
        public string feeDetlSn;
        public string orderNO;
        public string hisCode;
        public string hisName;
        public string insuCode;
        public string insuName;
        public string sumamt;
        public string count;
        public string price;
        public string billDeptCode;
        public string billDeptName;
        public string billDrCode;
        public string billDrName;
        public string acceptDeptCode;
        public string acceptDeptName;
        public string orderDrCode;
        public string orderDrName;
        public string limitUseFlag;
        DateTime occurTime;
        public string insuplc_admdvs;
        
    }

    //结算信息
    public struct Settlements
    {
        
        public int adm_Dr;
        public string mdtrtID;
        public string settlID;
        public string billID;
        public string recordID;
        public string clearingType;
        public string clearingWay;
        public string clearingOrgan;
        public string acctPay;
        public string psnCashPay;
        DateTime occurTime;
        public string dspoWay; //1继续执行 2修改医嘱
        public string dspoWayRea;

        public int hospitalizationsTimes;
        public int hospitalizationsDays;
        public string hisAdmTime;
        public string hisDischargeTime;

        public string minpacunt_drug_trac_cnt; //本次结算应上传最小包装追溯码数量
        public string mcs_trac_cnt; //本次结算应上传耗材追溯码数量
    }

    //当前环境实时信息
    public struct currentEnvironment
    {
        public  string path;
        public string mac;
        public string ip;

        public string signno;
        public string msgid;
        public string URL;
        public JArray jaSession;

        public CurEvtExtend ext;
    }
}
